var express = require('express'),
    fs = require('fs'),
    app;


app = express();

app.configure(function() {
  app.use(express.logger());
  app.use(express.bodyParser());
  app.use(express.cookieParser());
  app.use(express.favicon(__dirname + '/sources/favicon.ico', { 
    maxAge : 2592000000 
  }));
  app.engine('.html', function (fpath, data, fn) { 
    fs.readFile(fpath, 'utf-8', fn);          
  });
  app.use(express.methodOverride());
  app.use(app.router);
  app.use('/', express.static(__dirname + '/sources/'));
  app.use('/', express.directory(__dirname + '/sources/'));
  app.set('views', __dirname + '/sources/');
  app.set('view options', { 
    layout : false 
  });
  app.use(express.errorHandler({
    dumpExceptions : true, 
    showStack : true
  }));
});

app.listen(1234);
console.log('[...] localhost:' + 1234 + ', ' + 'video-testing');
