


var index = {
  resultsJSONPath : './support/results.json',
  videoJSONPath : './support/video.json',

  pad : function (n, width, z) {
    z = z || '0';
    n = n + '';
    return n.length >= width ? n : new Array(width - n.length + 1).join(z) + n;
  },

  settable : function (table, valsarr) {
    valsarr.map(function (vals) {
      var rcarr = vals[0],
          row   = rcarr[0], 
          cell  = rcarr[1]; 

      if ((row = table.rows[row]) &&
          (cell = row.cells[cell])) {

        // if there is a bold or italic element use that...
        cell = domchilds.getFirstElem(cell) || cell;
        cell.innerHTML = vals[1];
      }
    });
  },

  getstrategyarrfold : function (strategyarr) {
    var props = {
      'page-load to video-start'   : 0,
      'page-load to video-init'    : 0,
      'page-load to script-start'  : 0,
      'script-start to video-init' : 0,
      'video-init to video-start'  : 0
    };
    
    props = strategyarr.reduce(function (prev, data, i) {
      Object.keys(props).map(function (o) {
        prev[o] += data[o];
      });
      return prev;
    }, props);

    // be sure props > 0
    Object.keys(props).map(function (o) {
      var numarr;

      if (props[o]) {
        props[o] /= strategyarr.length;
        props[o] = Math.round(props[o] * 100) / 100;
        props[o] += '';
        
        if (/\./.test(props[o])) {
          numarr = (props[o] + '').split('.');
          numarr[0] = index.pad(numarr[0], 3, '&nbsp;');
          props[o] = numarr.join('.');
        } else {
          props[o] = index.pad(props[o], 3, '&nbsp;');          
        }
      } else {
        props[o] = '---';
      }
    });

    return props;
  },

  start_resultsform : function () {
    xhrgo.quickJSONU('GET', index.resultsJSONPath, null, null, function (err, resultsObj) {
      index_form.startresultsform(resultsObj, {
        formname : 'resultsform',
        formctrlarr : [{
          ctrlname : 'browsername',
          dataname : 'browserName'
        },{
          ctrlname : 'releaseurl',
          dataname : 'releaseURL'
        },{
          ctrlname : 'fullurl',
          dataname : 'fullURL'
        },{
          ctrlname : 'iscache',
          dataname : 'isCached',
          datafilter : function (data) {
            return String(data);
          }
        }]
      }, function (err, filteredresultsarr) {
        var title,
            strategyControl,
            strategyCurrent,
            strategySequential,
            strategyControlArr = [],
            strategyCurrentArr = [],
            strategySequentialArr = [];

        filteredresultsarr.map(function (result) {
          var strategy = result.strategy;
          
          if (strategy === 'current') {
            strategyCurrentArr.push(result);
          } else if (strategy === 'sequential') {
            strategySequentialArr.push(result);
          } else if (strategy === 'control') {
            strategyControlArr.push(result);
          }

          if (title && title !== result.browserName) {
            title = 'All Browsers';
          } else {
            title = result.browserName;
          }
        });

        strategyCurrent = 
          index.getstrategyarrfold(strategyCurrentArr);
        strategyControl = 
          index.getstrategyarrfold(strategyControlArr);
        strategySequential = 
          index.getstrategyarrfold(strategySequentialArr);

        index.settable(
          document.getElementsByTagName('table')[0], 
          [[[0, 0], title],
           [[1, 1], strategyControl['page-load to video-start']],
           [[2, 1], strategyControl['page-load to video-init']],
           [[3, 1], strategyControl['page-load to script-start']],
           [[4, 1], strategyControl['script-start to video-init']],
           [[5, 1], strategyControl['video-init to video-start']],

           [[1, 2], strategyCurrent['page-load to video-start']],
           [[2, 2], strategyCurrent['page-load to video-init']],
           [[3, 2], strategyCurrent['page-load to script-start']],
           [[4, 2], strategyCurrent['script-start to video-init']],
           [[5, 2], strategyCurrent['video-init to video-start']],

           [[1, 3], strategySequential['page-load to video-start']],
           [[2, 3], strategySequential['page-load to video-init']],
           [[3, 3], strategySequential['page-load to script-start']],
           [[4, 3], strategySequential['script-start to video-init']],
           [[5, 3], strategySequential['video-init to video-start']]]);
      });
    });
  },





    printResult : function (player, strategy, err, videostartms, videoinitms) {
      var isCached = juicycookie.getValue('videotest') ? true : false;

      // below is taken from stackoverflow page
      // http://stackoverflow.com/questions/11219582/how-to-detect-my-browser-version-and-operating-system-using-javascript
      //
      var nVer = navigator.appVersion;
      var nAgt = navigator.userAgent;
      var browserName  = navigator.appName;
      var fullVersion  = ''+parseFloat(navigator.appVersion); 
      var majorVersion = parseInt(navigator.appVersion,10);
      var nameOffset,verOffset,ix;

      // In Opera, the true version is after "Opera" or after "Version"
      if ((verOffset=nAgt.indexOf("Opera"))!=-1) {
        browserName = "Opera";
        fullVersion = nAgt.substring(verOffset+6);
        if ((verOffset=nAgt.indexOf("Version"))!=-1) 
          fullVersion = nAgt.substring(verOffset+8);
      }
      // In MSIE, the true version is after "MSIE" in userAgent
      else if ((verOffset=nAgt.indexOf("MSIE"))!=-1) {
        browserName = "Microsoft Internet Explorer";
        fullVersion = nAgt.substring(verOffset+5);
      }
      // In Chrome, the true version is after "Chrome" 
      else if ((verOffset=nAgt.indexOf("Chrome"))!=-1) {
        browserName = "Chrome";
        fullVersion = nAgt.substring(verOffset+7);
      }
      // In Safari, the true version is after "Safari" or after "Version" 
      else if ((verOffset=nAgt.indexOf("Safari"))!=-1) {
        browserName = "Safari";
        fullVersion = nAgt.substring(verOffset+7);
        if ((verOffset=nAgt.indexOf("Version"))!=-1) 
          fullVersion = nAgt.substring(verOffset+8);
      }
      // In Firefox, the true version is after "Firefox" 
      else if ((verOffset=nAgt.indexOf("Firefox"))!=-1) {
        browserName = "Firefox";
        fullVersion = nAgt.substring(verOffset+8);
      }
      // In most other browsers, "name/version" is at the end of userAgent 
      else if ( (nameOffset=nAgt.lastIndexOf(' ')+1) < 
                (verOffset=nAgt.lastIndexOf('/')) ) 
      {
        browserName = nAgt.substring(nameOffset,verOffset);
        fullVersion = nAgt.substring(verOffset+1);
        if (browserName.toLowerCase()==browserName.toUpperCase()) {
          browserName = navigator.appName;
        }
      }
      // trim the fullVersion string at semicolon/space if present
      if ((ix=fullVersion.indexOf(";"))!=-1)
        fullVersion=fullVersion.substring(0,ix);
      if ((ix=fullVersion.indexOf(" "))!=-1)
        fullVersion=fullVersion.substring(0,ix);

      majorVersion = parseInt(''+fullVersion,10);
      if (isNaN(majorVersion)) {
        fullVersion  = ''+parseFloat(navigator.appVersion); 
        majorVersion = parseInt(navigator.appVersion,10);
      }

      console.log((
        '{\n' +
        '  "browserName" : ":browserName",\n' +
        '  "browserFullVersion" : ":browserFullVersion",\n' +
        '  "browserMajorVersion" : ":browserMajorVersion",\n' +
        '  "navigatorappName" : ":navigatorappName",\n' +
        '  "navigatoruserAgent" : ":navigatoruserAgent",\n' +
        '  "whArr" : [:width, :height],\n' +
        '  "fullURL" : ":fullURL",\n' +
        '  "releaseURL" : ":releaseURL",\n' +
        '  "isCached" : :isCached,\n' +
        '  "strategy" : ":strategy",\n' +
        '  "err" : ":err",\n' +
        '  "page-load to video-start" : :ss1,\n' +
        '    "page-load to video-init"   : :ss2,\n' +
        '      "page-load to script-start"  : :ss3,\n' +
        '      "script-start to video-init" : :ss4,\n' +
        '    "video-init to video-start" : :ss5\n' +
        '}').replace(/:fullURL/, encodeURIComponent(window.location.href))
            .replace(/:releaseURL/, encodeURIComponent(player.releaseURL))
            .replace(/:isCached/, isCached)
            .replace(/:strategy/, strategy)
            .replace(/:browserName/, browserName)
            .replace(/:browserFullVersion/, fullVersion) 
            .replace(/:browserMajorVersion/, majorVersion)
            .replace(/:navigatorappName/, navigator.appName)       
            .replace(/:navigatoruserAgent/, navigator.userAgent)       
            .replace(/:width/, domwh.window()[0])       
            .replace(/:height/, domwh.window()[1])       
            .replace(/:err/, err)
            .replace(/:ss1/, Math.round((videostartms - pagestartms)  / 10) / 100)
            .replace(/:ss2/, Math.round((videoinitms - pagestartms)   / 10) / 100)
            .replace(/:ss3/, Math.round((scriptstartms - pagestartms) / 10) / 100)
            .replace(/:ss4/, Math.round((videoinitms - scriptstartms) / 10) / 100)
            .replace(/:ss5/, Math.round((videostartms - videoinitms)  / 10) / 100));
                
      juicycookie.persist('videotest', 'true', {
        expires : { hh : 24 }
      });                
    },

  releaseURL_baseurl : "http://link.theplatform.com/s/BKQ29B/:videoid?mbr=true&assetTypes=Video&feed=Fox%20Sports%20All",
  qa4current_baseurl : 'http://qa3.foxsports.com/nfl/video?vid=418805827517&videotest=true&releaseURL=:releaseURL',
  neoref_baseurl : 'http://player.foxneodigital.com/v1.6.2_554/reference/?network=sports&version=prod&debug=&elem=video-player&width=640&height=360&releaseURL=:releaseURL&autoplay=:autoplay&golive_show=&share=&share_deeplink=&share_deeplinkfunc=&share_showembedfunc=&share_embed=&share_fb=&endcard=&endcard_feed=&endcard_playlist=&endcard_related=',
  local_baseurl : './?videoid=:videoid&iu=:iu&autoplay=:autoplay',

  getasreleaseurl : function (opts) {
    var releaseurl = this.releaseURL_baseurl
                       .replace(/:videoid/, opts.videoid);

    if (opts.iu) {
      releaseurl += '&iu=' + opts.iu;
    }
    
    return releaseurl;
  },

  getasreleaseurlencoded : function (opts) {
    return encodeURIComponent(index.getasreleaseurl(opts));
  },

  gettestserviceqalinkhref : function (opts) {
    return this.qa4current_baseurl.replace(/:releaseURL/, index.getasreleaseurlencoded(opts));
  },

  gettestserviceqaseqlinkhref : function (opts) {
    return this.qa4current_baseurl.replace(/:releaseURL/, index.getasreleaseurlencoded(opts)) + '&load-alone=true&load-seq=true';
  },
  
  getreferenceservicelinkhref : function (opts) {
    return this.neoref_baseurl.replace(/:releaseURL/, index.getasreleaseurlencoded(opts)).replace(/:autoplay/, opts.autoplay);
  },

  getlocalservicelinkhref : function (opts) {
    return this.local_baseurl
      .replace(/:videoid/, opts.videoid)
      .replace(/:iu/, opts.iu)      
      .replace(/:autoplay/, opts.autoplay);
  },

  breakword : function (str, maxlength) {
    var bw = index.breakword;

    if (str.length < maxlength) {
      str = '<span>' + str + '</span>';
    } else {
      str = 
        bw(str.slice(0, maxlength - 1), maxlength) + 
        bw(str.slice(maxlength), maxlength);
    }
      
    return str;
  },

  getformvals : function (form) {
    var vals = {};
    if (form) {
      [].map.call(form.elements, function (elements) {
        elements.name && (vals[elements.name] = elements.value);
      });
    }

    return vals;
  },

  rebuildvideolinks : function (form) {
    var formvals = index.getformvals(form),

        testserviceqalink = document.getElementById('testservicelink'),
        testserviceqaseqlink = document.getElementById('testserviceqalink'),
        referenceservicelink = document.getElementById('referenceservicelink'),
        localservicelink = document.getElementById('localservicelink'),

        testserviceqalinkhref = 
          index.gettestserviceqalinkhref(formvals),
        testserviceqaseqlinkhref = 
          index.gettestserviceqaseqlinkhref(formvals),
        referenceservicelinkhref = 
          index.getreferenceservicelinkhref(formvals),
        localservicelinkhref = // should be made to work
          index.getlocalservicelinkhref(formvals);

    testserviceqalink.innerHTML = index.breakword(testserviceqalinkhref, 70);
    testserviceqalink.href = testserviceqalinkhref;

    testserviceqaseqlink.innerHTML = index.breakword(testserviceqaseqlinkhref, 70);
    testserviceqaseqlink.href = testserviceqaseqlinkhref;

    referenceservicelink.innerHTML = index.breakword(referenceservicelinkhref, 70);
    referenceservicelink.href = referenceservicelinkhref;

    localservicelink.innerHTML = index.breakword(localservicelinkhref, 70);
    localservicelink.href = localservicelinkhref;
  },

  start_videoform : function () {
    var form = index_form.getform({}, 'neoform'),
        elemid = 'video-player';

    index.rebuildvideolinks(form);

    if (form) {
      form.onchange = function () {
        index.rebuildvideolinks(form);
      };

      form.onsubmit = function (e) {
        var formvals = index.getformvals(form);
            //videoinitms = Date.now();

        var videoplayerelem = document.getElementById(elemid);
        if (videoplayerelem) {
          videoplayerelem.innerHTML = '';
        }

        index_video.loadandplay({
          elemid : 'video-player',
          autoplay : formvals.autoplay === 'true',
          releaseURL : index.getasreleaseurl(formvals)
        }, function (err, player) {

        });

        return e.preventDefault() && false;
      };

      form.elements.videoclear.onclick = function () {
        var videoplayerelem = document.getElementById(elemid);
        if (videoplayerelem) {
          videoplayerelem.innerHTML = '';
        }
      };
    }

    // get parameters from url...
    var argsobj = xhrgo.getUriStrAsArgsObj(window.location.href);
    if (argsobj.videoid) {
      var videoinitms = Date.now();
      index_video.loadandplay({
        elemid : 'video-player',
        autoplay : argsobj.autoplay === 'true',
        releaseURL : index.getasreleaseurl(argsobj)
      }, function (err, player) {
        var videostartms = Date.now();
        index.printResult(player, 'local', null, videostartms, videoinitms);
      });

      /*
      // should also populate controls....
      [].map.call(form.elements, function (elements) {
        console.log('element', elements.name, elements.value, argsobj[elements.name]);
        if (elements.value === argsobj[elements.name]) {
          elements.selected = true;
        }
      });     
       */
    }
  },

  start : function () {
    lazyload.js([
      './support/xhrgo.js',
      './support/domwh.js',
      './support/domchilds.js',
      './support/juicycookie.js',
      './index_form.js',
      './index_video.js'
    ], function () {
      index.start_resultsform();
      index.start_videoform();
    });
  }
};
