
var index_form = {
  resultsJSONPath : '/support/results.json',

  getStrAsSelectOption : function (name, val) {
    var o = document.createElement('option');      
    o.textContent = decodeURIComponent(name);
    o.value = typeof val === 'string' ? val : name;

    return o;
  },
  
  getDataCtrlAsReset : function (datactrl) {
    datactrl.innerHTML = '';
    datactrl.appendChild(index_form.getStrAsSelectOption('---', ''));
    return datactrl;
  },

  getDataArrAsUniquePropArr : function (dataArr, prop) {
    return dataArr.map(function (data) {
      return data[prop];
    }).sort().filter(function (name, i, arr) {
      return arr[++i] !== name;
    });
  },

  getform : function (opts, formname) {
    return document.forms[formname];
  },

  getformctrl : function (opts, ctrlname) {
    var form = index_form.getform(opts, opts.formname);
    if (form) {
      return form.elements[ctrlname];
    } else {
      throw new Error('undefined form ' + opts.formname);
    }
  },

  populatectrl : function (opts, data, ctrlname, dataname) {
    var datactrl = index_form.getformctrl(opts, ctrlname),
        datactrlval = datactrl.value,
        dataarr = index_form.getDataArrAsUniquePropArr(data, dataname);

    datactrl = index_form.getDataCtrlAsReset(datactrl);
    dataarr.map(function (str) {
      var datactrloption = index_form.getStrAsSelectOption(str);
      if (datactrloption.value === datactrlval) {
        datactrloption.selected = true;
      }

      datactrl.appendChild(datactrloption);
    });
  },

  populatectrlarr : function (opts, data, ctrlsarr) {
    ctrlsarr.map(function (ctrl) {
      index_form.populatectrl(opts, data, ctrl.ctrlname, ctrl.dataname);
    });
  },

  getfilteredctrlsarrdataarr: function (opts, dataarr, ctrlsarr) {
    //var filteredresultsobj = resultsObj.slice();
    var filteredresultsobj = dataarr.slice();
    
    ctrlsarr.map(function (formctrl) {
      var ctrl = index_form.getformctrl(opts, formctrl.ctrlname),
          dataval;

      if (ctrl && ctrl.value) {
        filteredresultsobj = filteredresultsobj.filter(function (data) {
          dataval = data[formctrl.dataname];
          
          if (typeof formctrl.datafilter === 'function') {
            return formctrl.datafilter(dataval) === ctrl.value;
          } else {
            return dataval === ctrl.value;
          }
        });
      }
    });

    return filteredresultsobj;
  },

  startresultsform : function (resultsObj, opts, fn) {
    var form = index_form.getform(opts, opts.formname);

    index_form.populatectrlarr(opts, resultsObj, opts.formctrlarr);

    form.onsubmit = function (e) {
      return e.preventDefault() && false;
    };
    form.onchange = function (e) {
      // find which ones have values...
      // and collect 
      var selectedctrlarr = [],
          unselectedctrlarr = [];

      opts.formctrlarr.map(function (formctrl) {
        var ctrl = index_form.getformctrl(opts, formctrl.ctrlname);
        if (ctrl && ctrl.value) {
          selectedctrlarr.push(formctrl);
        } else {
          unselectedctrlarr.push(formctrl);
        }
      });

      
      var filteredresultsobj = 
            index_form.getfilteredctrlsarrdataarr(opts, resultsObj, selectedctrlarr);

      // once filtered results are achieved...
      // remove non-rebuild unselected form ctrls
      unselectedctrlarr.map(function (formctrl) {
        index_form.populatectrl(opts, filteredresultsobj, formctrl.ctrlname, formctrl.dataname);
      });

      selectedctrlarr.map(function (formctrl) {
        // remove this ctrls selection from the arr
        // if possible values are true and false ...
        // both should be selectable if other ctrl values do not prevent
        var newfiltered = 
            index_form.getfilteredctrlsarrdataarr(opts, resultsObj, selectedctrlarr.filter(function (ctrl) {
              return ctrl.ctrlname !== formctrl.ctrlname;
            }));      

        // narrow results to those visible on this ctrl
        index_form.populatectrl(opts, newfiltered, formctrl.ctrlname, formctrl.dataname);    
      });
      

      fn(null, filteredresultsobj);
    };
  }
};
